# DelayEmbeddings.jl

![DynamicalSystems.jl logo: The Double Pendulum](https://i.imgur.com/nFQFdB0.gif)

| **Documentation**   |  **Tests**     |  Gitter |
|:--------:|:-------------------:|:-----:|
|[![](https://img.shields.io/badge/docs-latest-blue.svg)](https://JuliaDynamics.github.io/DynamicalSystems.jl/dev) | [![CI](https://github.com/juliadynamics/DelayEmbedding.jl/workflows/CI/badge.svg)](https://github.com/JuliaDynamics/DelayEmbedding.jl/actions)  | [![Gitter](https://img.shields.io/gitter/room/nwjs/nw.js.svg)](https://gitter.im/JuliaDynamics/Lobby)


Contained here:

1. Defines the `Dataset` structure, which is a wrapper of `Vector{SVector}`, used in **DynamicalSystems.jl**.
2. Implements methods for delay coordinates embedding with high performance and many features.
3. Algorithms for estimating optimal delay embedding parameters, the delay time and the number of temporal neighbors (generalization of the "embedding dimension").
4. New, _unified_ algorithms for optimal delay embedding.
